- name: Wipe Configuration
  hosts: spine,leaf
  become: yes
  roles:
  - reset

- name: Lab 1 Setup PTM
  hosts: leaf01,leaf02,spine01
  become: yes
  tasks:
  - name: Download the topology.dot file from the OOB-MGMT-SERVER
    get_url:
      url: http://192.168.0.254/topology.dot
      dest: /etc/ptm.d/topology.dot
      mode: 0755

  - name: Restart PTM Daemon to Apply new Topology.dot file
    service: name=ptmd state=restarted

  - name: Test PTM
    shell: ptmctl
    register: ptm_output
    failed_when: ('pass' not in ptm_output.stdout)

  - name: Install License
    shell: cl-license -i http://192.168.0.254/license.lic
    register: cllicense_output
    failed_when: ('License file installed.' not in cllicense_output.stdout)


- name: Configure SVI and EVPN on Leaf01 and Leaf02 Switches
  hosts: leaf01:leaf02
  become: yes
  vars:
    devices:
        leaf01:
            loopback: "10.255.255.1/32"
            bgpasn: "65100"
            rr: "10.255.255.101"
            VLANS:
                - vlan: "10"
                  vrrip: "10.0.10.1/24"
                  vrrmac: "00:00:00:00:1a:10"
                  interface: "swp1"
                  realip: "10.0.10.2/24"
                - vlan: "20"
                  vrrip: "10.0.20.1/24"
                  vrrmac: "00:00:00:00:1a:20"
                  interface: "swp1"
                  realip: "10.0.20.2/24"
        leaf02:
            loopback: "10.255.255.2/32"
            bgpasn: "65100"
            rr: "10.255.255.101"
            VLANS:
                - vlan: "10"
                  vrrip: "10.0.10.1/24"
                  vrrmac: "00:00:00:00:1a:10"
                  interface: "swp2"
                  realip: "10.0.10.3/24"
                - vlan: "20"
                  vrrip: "10.0.20.1/24"
                  vrrmac: "00:00:00:00:1a:20"
                  interface: "swp2"
                  realip: "10.0.20.3/24"

  tasks:
  - name: Lab 6 -- Deploy Leaf interface configuration
    nclu:
        commit: true
        description: "Deploy Lab6 interface configuration"
        commands:
            - add loopback lo ip address {{ devices[ansible_hostname].loopback }}

  - name: Lab 6 -- Deploy Leaf FRR configuration
    nclu:
        commit: true
        description: "Deploy Lab6 FRR configuration"
        commands:

            - add loopback lo ospf area 0
            - add interface swp51 ip address {{ devices[ansible_hostname].loopback }}
            - add ospf router-id {{ devices[ansible_hostname].loopback[:-3] }}
            - add interface swp51 ospf area 0
            - add interface swp51 ospf network point-to-point
            - add bgp autonomous-system {{ devices[ansible_hostname].bgpasn }}
            - add bgp neighbor {{ devices[ansible_hostname].rr }} remote-as internal
            - add bgp neighbor {{ devices[ansible_hostname].rr }} update-source lo



- name: Configure Spines
  hosts: spine01
  become: yes
  vars:
    devices:
        spine01:
            loopback: "10.255.255.101/32"
            bgpasn: "65100"
            leaf01: "10.255.255.1"
            leaf02: "10.255.255.2"
        spine02:
            loopback: "10.255.255.102/32"
            bgpasn: "65100"
            leaf01: "10.255.255.1"
            leaf02: "10.255.255.2"
  tasks:
  - name: Lab 6 -- Deploy Configuration on Spine01
    nclu:
        commit: true
        description: "Deploy interface configuration"
        commands:
            - add loopback lo ip address {{ devices[ansible_hostname].loopback }}
            - add interface swp1-4
            - add bgp autonomous-system {{ devices[ansible_hostname].bgpasn }}
            - add bgp neighbor {{ devices[ansible_hostname].leaf01 }} remote-as internal
            - add bgp neighbor {{ devices[ansible_hostname].leaf01 }} update-source lo
            - add bgp neighbor {{ devices[ansible_hostname].leaf01 }} route-reflector-client
            - add bgp neighbor {{ devices[ansible_hostname].leaf02 }} remote-as internal
            - add bgp neighbor {{ devices[ansible_hostname].leaf02 }} update-source lo
            - add bgp neighbor {{ devices[ansible_hostname].leaf02 }} route-reflector-client
            - add loopback lo ospf area 0
            - add interface swp1 ip address {{ devices[ansible_hostname].loopback }}
            - add interface swp2 ip address {{ devices[ansible_hostname].loopback }}
            - add ospf router-id {{ devices[ansible_hostname].loopback[:-3] }}
            - add interface swp1 ospf area 0
            - add interface swp1 ospf network point-to-point
            - add interface swp2 ospf area 0
            - add interface swp2 ospf network point-to-point

- name: Server Configuration
  hosts: server01,server02
  become: yes
  tasks:
  - name: Copy Interfaces Configuration File
    copy: src=./{{ ansible_hostname }}_lab6.cfg dest=/etc/network/interfaces

  - name: Restart Networking
    service: name=networking state=restarted

